"use strict";
/*
 * Copyright (c) 2014-2022 Bjoern Kimminich & the OWASP Juice Shop contributors.
 * SPDX-License-Identifier: MIT
 */
Object.defineProperty(exports, "__esModule", { value: true });
const config = require("config");
const protractor_1 = require("protractor");
const e2eHelpers_1 = require("./e2eHelpers");
describe('/#/administration', () => {
    describe('challenge "adminSection"', () => {
        (0, e2eHelpers_1.beforeEachLogin)({ email: `admin@${config.get('application.domain')}`, password: 'admin123' });
        it('should be possible to access administration section with admin user', () => {
            void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/administration`);
            expect(protractor_1.browser.getCurrentUrl()).toMatch(/\/administration/);
        });
        (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'Admin Section' });
    });
    describe('challenge "fiveStarFeedback"', () => {
        (0, e2eHelpers_1.beforeEachLogin)({ email: `admin@${config.get('application.domain')}`, password: 'admin123' });
        it('should be possible for any admin user to delete feedback', () => {
            void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/administration`);
            void (0, protractor_1.$$)('.mat-cell.mat-column-remove > button').first().click();
        });
        (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'Five-Star Feedback' });
    });
});
//# sourceMappingURL=administrationSpec.js.map