"use strict";
/*
 * Copyright (c) 2014-2022 Bjoern Kimminich & the OWASP Juice Shop contributors.
 * SPDX-License-Identifier: MIT
 */
Object.defineProperty(exports, "__esModule", { value: true });
const config = require("config");
const protractor_1 = require("protractor");
const e2eHelpers_1 = require("./e2eHelpers");
describe('/#/privacy-security/data-export', () => {
    xdescribe('challenge "dataExportChallenge"', () => {
        beforeEach(() => {
            void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/register`);
            void (0, protractor_1.element)(protractor_1.by.id('emailControl')).sendKeys(`admun@${config.get('application.domain')}`);
            void (0, protractor_1.element)(protractor_1.by.id('passwordControl')).sendKeys('admun123');
            void (0, protractor_1.element)(protractor_1.by.id('repeatPasswordControl')).sendKeys('admun123');
            void (0, protractor_1.element)(protractor_1.by.name('securityQuestion')).click();
            void protractor_1.element.all(protractor_1.by.cssContainingText('mat-option', 'Your eldest siblings middle name?')).click();
            void (0, protractor_1.element)(protractor_1.by.id('securityAnswerControl')).sendKeys('admun');
            void (0, protractor_1.element)(protractor_1.by.id('registerButton')).click();
        });
        (0, e2eHelpers_1.beforeEachLogin)({ email: `admun@${config.get('application.domain')}`, password: 'admun123' });
        it('should be possible to steal admin user data by causing email clash during export', () => {
            void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/privacy-security/data-export`);
            void (0, protractor_1.element)(protractor_1.by.id('formatControl')).all(protractor_1.by.tagName('mat-radio-button')).get(0).click();
            void (0, protractor_1.element)(protractor_1.by.id('submitButton')).click();
        });
        (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'GDPR Data Theft' });
    });
});
//# sourceMappingURL=dataExportSpec.js.map