"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * Copyright (c) 2014-2022 Bjoern Kimminich & the OWASP Juice Shop contributors.
 * SPDX-License-Identifier: MIT
 */
const utils = require("../../lib/utils");
const protractor_1 = require("protractor");
const e2eHelpers_1 = require("./e2eHelpers");
describe('/', () => {
    describe('challenge "jwtUnsigned"', () => {
        it('should accept an unsigned token with email jwtn3d@juice-sh.op in the payload ', () => {
            void protractor_1.browser.executeScript('localStorage.setItem("token", "eyJhbGciOiJub25lIiwidHlwIjoiSldUIn0.eyJkYXRhIjp7ImVtYWlsIjoiand0bjNkQGp1aWNlLXNoLm9wIn0sImlhdCI6MTUwODYzOTYxMiwiZXhwIjo5OTk5OTk5OTk5fQ.")');
            void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/`);
        });
        (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'Unsigned JWT' });
    });
    if (!utils.disableOnWindowsEnv()) {
        describe('challenge "jwtForged"', () => {
            it('should accept a token HMAC-signed with public RSA key with email rsa_lord@juice-sh.op in the payload ', () => {
                void protractor_1.browser.executeScript('localStorage.setItem("token", "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJkYXRhIjp7ImVtYWlsIjoicnNhX2xvcmRAanVpY2Utc2gub3AifSwiaWF0IjoxNTgzMDM3NzExfQ.gShXDT5TrE5736mpIbfVDEcQbLfteJaQUG7Z0PH8Xc8")');
                void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/`);
            });
            (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'Forged Signed JWT' });
        });
    }
});
//# sourceMappingURL=forgedJwtSpec.js.map