"use strict";
/*
 * Copyright (c) 2014-2022 Bjoern Kimminich & the OWASP Juice Shop contributors.
 * SPDX-License-Identifier: MIT
 */
Object.defineProperty(exports, "__esModule", { value: true });
const protractor_1 = require("protractor");
const e2eHelpers_1 = require("./e2eHelpers");
describe('/redirect', () => {
    describe('challenge "redirect"', () => {
        it('should show error page when supplying an unrecognized target URL', () => {
            void protractor_1.browser.driver.get(`${protractor_1.browser.baseUrl}/redirect?to=http://kimminich.de`).then(() => {
                expect(protractor_1.browser.driver.getPageSource()).toContain('Unrecognized target URL for redirect: http://kimminich.de');
            });
        });
    });
    describe('challenge "redirect"', () => {
        it('should redirect to target URL if allowlisted URL is contained in it as parameter', () => {
            void protractor_1.browser.driver.get(`${protractor_1.browser.baseUrl}/redirect?to=https://owasp.org?trickIndexOf=https://github.com/bkimminich/juice-shop`).then(() => {
                expect(protractor_1.browser.driver.getCurrentUrl()).toMatch(/https:\/\/owasp\.org/);
            });
        });
        (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'Allowlist Bypass' });
    });
    describe('challenge "redirectCryptoCurrency"', () => {
        it('should still redirect to forgotten entry https://etherscan.io/address/0x0f933ab9fcaaa782d0279c300d73750e1311eae6 on allowlist', () => {
            void protractor_1.browser.driver.get(`${protractor_1.browser.baseUrl}/redirect?to=https://etherscan.io/address/0x0f933ab9fcaaa782d0279c300d73750e1311eae6`);
        });
        (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'Outdated Allowlist' });
    });
});
//# sourceMappingURL=redirectSpec.js.map