"use strict";
/*
 * Copyright (c) 2014-2022 Bjoern Kimminich & the OWASP Juice Shop contributors.
 * SPDX-License-Identifier: MIT
 */
Object.defineProperty(exports, "__esModule", { value: true });
const config = require("config");
const protractor_1 = require("protractor");
const e2eHelpers_1 = require("./e2eHelpers");
describe('/#/score-board', () => {
    describe('challenge "scoreBoard"', () => {
        it('should be possible to access score board', () => {
            void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/score-board`);
            expect(protractor_1.browser.getCurrentUrl()).toMatch(/\/score-board/);
        });
        (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'Score Board' });
    });
    describe('challenge "continueCode"', () => {
        it('should be possible to solve the non-existent challenge #99', () => {
            protractor_1.browser.executeScript(`var xhttp = new XMLHttpRequest(); xhttp.onreadystatechange = function() { if (this.status == 200) { console.log("Success"); } }; xhttp.open("PUT","${protractor_1.browser.baseUrl}/rest/continue-code/apply/69OxrZ8aJEgxONZyWoz1Dw4BvXmRGkM6Ae9M7k2rK63YpqQLPjnlb5V5LvDj", true); xhttp.setRequestHeader("Content-type","text/plain"); xhttp.send();`); // eslint-disable-line
            void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/score-board`);
        });
        (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'Imaginary Challenge' });
    });
    describe('repeat notification', () => {
        let alertsBefore, alertsNow;
        beforeEach(() => {
            void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/score-board`);
        });
        if (config.get('challenges.showSolvedNotifications') && config.get('ctf.showFlagsInNotifications')) {
            it('should be possible when in CTF mode', () => {
                alertsBefore = protractor_1.element.all(protractor_1.by.className('challenge-solved-toast')).count();
                void (0, protractor_1.element)(protractor_1.by.id('Score Board.solved')).click();
                alertsNow = protractor_1.element.all(protractor_1.by.className('challenge-solved-toast')).count();
                expect(alertsBefore).not.toBe(alertsNow);
            });
        }
        else {
            it('should not be possible when not in CTF mode', () => {
                alertsBefore = protractor_1.element.all(protractor_1.by.className('challenge-solved-toast')).count();
                void (0, protractor_1.element)(protractor_1.by.id('Score Board.solved')).click();
                alertsNow = protractor_1.element.all(protractor_1.by.className('challenge-solved-toast')).count();
                expect(alertsBefore).toBe(alertsNow);
            });
        }
    });
});
//# sourceMappingURL=scoreBoardSpec.js.map