"use strict";
/*
 * Copyright (c) 2014-2022 Bjoern Kimminich & the OWASP Juice Shop contributors.
 * SPDX-License-Identifier: MIT
 */
Object.defineProperty(exports, "__esModule", { value: true });
const protractor_1 = require("protractor");
const utils = require("../../lib/utils");
const e2eHelpers_1 = require("./e2eHelpers");
describe('/#/track-order', () => {
    if (!utils.disableOnContainerEnv()) {
        describe('challenge "reflectedXss"', () => {
            it('Order Id should be susceptible to reflected XSS attacks', () => {
                const EC = protractor_1.protractor.ExpectedConditions;
                void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/track-result`);
                void protractor_1.browser.waitForAngularEnabled(false);
                void protractor_1.browser.get(`${e2eHelpers_1.basePath}/#/track-result?id=<iframe src="javascript:alert(\`xss\`)">`);
                void protractor_1.browser.refresh();
                void protractor_1.browser.wait(EC.alertIsPresent(), 5000, "'xss' alert is not present on /#/track-result ");
                void protractor_1.browser.switchTo().alert().then(alert => {
                    expect(alert.getText()).toEqual(Promise.resolve('xss'));
                    void alert.accept();
                });
                void protractor_1.browser.waitForAngularEnabled(true);
            });
            (0, e2eHelpers_1.expectChallengeSolved)({ challenge: 'Reflected XSS' });
        });
    }
});
//# sourceMappingURL=trackOrderSpec.js.map